function varargout = guiSurface(varargin)
% GUISURFACE M-file for guiSurface.fig
%      GUISURFACE, by itself, creates a new GUISURFACE or raises the existing
%      singleton*.
%
%      H = GUISURFACE returns the handle to a new GUISURFACE or the handle to
%      the existing singleton*.
%
%      GUISURFACE('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in GUISURFACE.M with the given input arguments.
%
%      GUISURFACE('Property','Value',...) creates a new GUISURFACE or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before guiSurface_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to guiSurface_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help guiSurface

% Last Modified by GUIDE v2.5 21-Jul-2010 01:05:32

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @guiSurface_OpeningFcn, ...
                   'gui_OutputFcn',  @guiSurface_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before guiSurface is made visible.
function guiSurface_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to guiSurface (see VARARGIN)

% Choose default command line output for guiSurface
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes guiSurface wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = guiSurface_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;

function updateExpression(hObject)
    set(hObject,'String','1')

function dep=getDependentVariable(handles)
    switch get(handles.popDependentVariable,'Value')
        case 1
            dep='r';
        case 2
            dep='t';
        case 3
            dep='p';
    end

function updateIndepRange(handles)
    dep=getDependentVariable(handles);
    set(handles.sldIndep1Min,'Value',0)
    set(handles.sldIndep1Max,'Value',0)
    set(handles.sldIndep2Min,'Value',0)
    set(handles.sldIndep2Max,'Value',0)
    switch (dep)
        case 'r'
            set(handles.pnlIndep1Range,'Title','Range of theta')
            set(handles.pnlIndep2Range,'Title','Range of phi')
            set(handles.sldIndep1Min,'Max',pi)
            set(handles.sldIndep1Max,'Max',pi)
            set(handles.sldIndep2Min,'Max',2*pi)
            set(handles.sldIndep2Max,'Max',2*pi)
        case 't'
            set(handles.pnlIndep1Range,'Title','Range of radius')
            set(handles.pnlIndep2Range,'Title','Range of phi')
            set(handles.sldIndep1Min,'Max',100)
            set(handles.sldIndep1Max,'Max',100)
            set(handles.sldIndep2Min,'Max',2*pi)
            set(handles.sldIndep2Max,'Max',2*pi)
        case 'p'
            set(handles.pnlIndep1Range,'Title','Range of radius')
            set(handles.pnlIndep2Range,'Title','Range of theta')
            set(handles.sldIndep1Min,'Max',100)
            set(handles.sldIndep1Max,'Max',100)
            set(handles.sldIndep2Min,'Max',pi)
            set(handles.sldIndep2Max,'Max',pi)
    end
    
function updateRangeString(handles)
    dep=getDependentVariable(handles);
    indep1Min=get(handles.sldIndep1Min,'Value');
    indep1Max=get(handles.sldIndep1Max,'Value');
    indep2Min=get(handles.sldIndep2Min,'Value');
    indep2Max=get(handles.sldIndep2Max,'Value');
    switch (dep)
        case 'r'
            RangeString1=strcat('Theta from ',mat2str(indep1Min),' to ',mat2str(indep1Max));
            RangeString2=strcat('Phi from ',mat2str(indep2Min),' to ',mat2str(indep2Max));
        case 't'
            RangeString1=strcat('Radius from ',mat2str(indep1Min),' to ',mat2str(indep1Max));
            RangeString2=strcat('Phi from ',mat2str(indep2Min),' to ',mat2str(indep2Max));
        case 'p'
            RangeString1=strcat('Radius from ',mat2str(indep1Min),' to ',mat2str(indep1Max));
            RangeString2=strcat('Theta from ',mat2str(indep2Min),' to ',mat2str(indep2Max));
    end
    set(handles.lblIndep1Range,'String',RangeString1)
    set(handles.lblIndep2Range,'String',RangeString2)
    
function plotExpression(handles)
    dep=getDependentVariable(handles);
    expression=get(handles.txtExpression,'String');
    indep1Min=get(handles.sldIndep1Min,'Value');
    indep1Max=get(handles.sldIndep1Max,'Value');
    indep2Min=get(handles.sldIndep2Min,'Value');
    indep2Max=get(handles.sldIndep2Max,'Value');
    switch (dep)
        case 'r'
            plotSurfacer(handles.axes,expression,indep1Min,indep1Max,indep2Min,indep2Max)
        case 't'
            plotSurfacet(handles.axes,expression,indep1Min,indep1Max,indep2Min,indep2Max)
        case 'p'
            plotSurfacep(handles.axes,expression,indep1Min,indep1Max,indep2Min,indep2Max)
    end
            
% --- Executes during object creation, after setting all properties.
function popDependentVariable_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popDependentVariable (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes during object creation, after setting all properties.
function txtExpression_CreateFcn(hObject, eventdata, handles)
    updateExpression(hObject)
% hObject    handle to txtExpression (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes during object creation, after setting all properties.
function figure1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to figure1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called


% --- Executes on selection change in popDependentVariable.
function popDependentVariable_Callback(hObject, eventdata, handles)
    updateIndepRange(handles)
    updateExpression(handles.txtExpression)
    updateRangeString(handles)
% hObject    handle to popDependentVariable (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns popDependentVariable contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popDependentVariable


% --- Executes on slider movement.
function sldIndep2Min_Callback(hObject, eventdata, handles)
    updateRangeString(handles)
    plotExpression(handles)
% hObject    handle to sldIndep2Min (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider


% --- Executes during object creation, after setting all properties.
function sldIndep2Min_CreateFcn(hObject, eventdata, handles)
% hObject    handle to sldIndep2Min (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes on slider movement.
function sldIndep2Max_Callback(hObject, eventdata, handles)
    updateRangeString(handles)
    plotExpression(handles)
% hObject    handle to sldIndep2Max (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider


% --- Executes during object creation, after setting all properties.
function sldIndep2Max_CreateFcn(hObject, eventdata, handles)
% hObject    handle to sldIndep2Max (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes on slider movement.
function sldIndep1Min_Callback(hObject, eventdata, handles)
    updateRangeString(handles)
    plotExpression(handles)

% hObject    handle to sldIndep1Min (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider


% --- Executes during object creation, after setting all properties.
function sldIndep1Min_CreateFcn(hObject, eventdata, handles)
% hObject    handle to sldIndep1Min (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes on slider movement.
function sldIndep1Max_Callback(hObject, eventdata, handles)
    updateRangeString(handles)
    plotExpression(handles)
% hObject    handle to sldIndep1Max (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider


% --- Executes during object creation, after setting all properties.
function sldIndep1Max_CreateFcn(hObject, eventdata, handles)
% hObject    handle to sldIndep1Max (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes on button press in btnInitialize.
function btnInitialize_Callback(hObject, eventdata, handles)
% hObject    handle to btnInitialize (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)



function txtExpression_Callback(hObject, eventdata, handles)
% hObject    handle to txtExpression (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of txtExpression as text
%        str2double(get(hObject,'String')) returns contents of txtExpression as a double


